using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using java.util;
using java.util.zip;
using java.io;


namespace SharpZip
{
    public partial class Form1 : Form
    {
        string[] files;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void btnZip_Click(object sender, EventArgs e)
        {
            if (files != null)
            {
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    txtZip.Text = saveFileDialog1.FileName;
                    Zip(txtZip.Text.Trim(), files);
                }
            }
        }

        private List<ZipEntry> GetZipFiles(ZipFile zipfil)
        {
            List<ZipEntry> lstZip = new List<ZipEntry>();
            Enumeration zipEnum = zipfil.entries();
            while (zipEnum.hasMoreElements())
            {
                ZipEntry zip = (ZipEntry)zipEnum.nextElement();
                lstZip.Add(zip);
            }
            return lstZip;
        }

        private void Zip(string zipFileName, string[] sourceFile)
        {
            FileOutputStream filOpStrm = new FileOutputStream(zipFileName);
            ZipOutputStream zipOpStrm = new ZipOutputStream(filOpStrm);
            FileInputStream filIpStrm = null;

            foreach (string strFilName in sourceFile)
            {
                filIpStrm = new FileInputStream(strFilName);
                ZipEntry ze = new ZipEntry(Path.GetFileName(strFilName));
                zipOpStrm.putNextEntry(ze);
                sbyte[] buffer = new sbyte[1024];
                int len = 0;

                while ((len = filIpStrm.read(buffer)) >= 0)
                {
                    zipOpStrm.write(buffer, 0, len);
                }
            }

            zipOpStrm.closeEntry();
            filIpStrm.close();
            zipOpStrm.close();
            filOpStrm.close();
        }

        private void Extract(string zipFileName, string destinationPath)
        {
            FileInfo fInf = new FileInfo(zipFileName);
            progressBar1.Visible = true;
            progressBar2.Visible = true;

            progressBar1.Minimum = 0;
            progressBar1.Maximum = Convert.ToInt32((fInf.Length)/100);

            lstExtractedFiles.Items.Clear();
            ZipFile zipfile = new ZipFile(zipFileName);
            List<ZipEntry> zipFiles = GetZipFiles(zipfile);

            progressBar2.Minimum = 0;
            progressBar2.Maximum = zipFiles.Count;

            lstExtractedFiles.Items.Add("Files Extracted to: " + destinationPath);
            lstExtractedFiles.Items.Add("------------------------------------------------------------------------------------------------------------------------");
            foreach (ZipEntry zipFile in zipFiles)
            {
                if (!zipFile.isDirectory())
                {
                    InputStream s = zipfile.getInputStream(zipFile);
                    try
                    {
                        Directory.CreateDirectory(destinationPath + "\\" + Path.GetDirectoryName(zipFile.getName()));
                        FileOutputStream dest = new FileOutputStream(Path.Combine(destinationPath + "\\" + Path.GetDirectoryName(zipFile.getName()), Path.GetFileName(zipFile.getName())));
                        try
                        {
                            int len = 0;
                            sbyte[] buffer = new sbyte[8000];
                            while ((len = s.read(buffer)) >= 0)
                            {
                                dest.write(buffer, 0, len);
                                if (progressBar1.Value + (8000 / 1000) < progressBar1.Maximum)
                                {
                                    progressBar1.Value = (progressBar1.Value + (8000 / 1000));
                                }
                                else
                                {
                                    string d = "";
                                }
                                progressBar1.Refresh();
                            }
                        }
                        finally
                        {
                            dest.close();
                        }
                    }
                    finally
                    {
                        s.close();
                    }
                }
                lstExtractedFiles.Items.Add(zipFile.getName());
                lstExtractedFiles.Refresh();
                progressBar1.Value = 0;
                
                progressBar2.Value = progressBar2.Value + 1;
                progressBar2.Refresh();
            }
            progressBar2.Value = 0;

            progressBar1.Visible = false;
            progressBar2.Visible = false;
        }

        private void btnBrowse_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                files = openFileDialog1.FileNames;
                lstBoxFilesToZip.DataSource = files;
            }
        }

        private void btnExtract_Click(object sender, EventArgs e)
        {
            if(txtExtract.Text.Trim().Length > 0)
            {
                if(folderBrowserDialog1.ShowDialog() == DialogResult.OK)
                {
                    Extract(txtExtract.Text.Trim(), folderBrowserDialog1.SelectedPath);
                }
            }
        }

        private void btnExtractBrowse_Click(object sender, EventArgs e)
        {
            openFileDialog1.Multiselect = false;
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                txtExtract.Text = openFileDialog1.FileName;
                lstExtractedFiles.Items.Clear();
            }
            openFileDialog1.Multiselect = true;
        }
    }
}